/* Auto-generated by genmsg_cpp for file /tmp/buildd/ros-fuerte-speakeasy-0.1.3/debian/ros-fuerte-speakeasy/opt/ros/fuerte/stacks/speakeasy/msg/SpeakEasyMusic.msg */
#ifndef SPEAKEASY_MESSAGE_SPEAKEASYMUSIC_H
#define SPEAKEASY_MESSAGE_SPEAKEASYMUSIC_H
#include <string>
#include <vector>
#include <map>
#include <ostream>
#include "ros/serialization.h"
#include "ros/builtin_message_traits.h"
#include "ros/message_operations.h"
#include "ros/time.h"

#include "ros/macros.h"

#include "ros/assert.h"


namespace speakeasy
{
template <class ContainerAllocator>
struct SpeakEasyMusic_ {
  typedef SpeakEasyMusic_<ContainerAllocator> Type;

  SpeakEasyMusic_()
  : command(0)
  , song_name()
  , repeats(0)
  , volume(0.0)
  , time(0.0)
  , timeReference(0)
  {
  }

  SpeakEasyMusic_(const ContainerAllocator& _alloc)
  : command(0)
  , song_name(_alloc)
  , repeats(0)
  , volume(0.0)
  , time(0.0)
  , timeReference(0)
  {
  }

  typedef int8_t _command_type;
  int8_t command;

  typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _song_name_type;
  std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  song_name;

  typedef int8_t _repeats_type;
  int8_t repeats;

  typedef float _volume_type;
  float volume;

  typedef float _time_type;
  float time;

  typedef int8_t _timeReference_type;
  int8_t timeReference;

  enum { PLAY = 0 };
  enum { STOP = 1 };
  enum { PAUSE = 2 };
  enum { UNPAUSE = 3 };
  enum { SET_VOL = 4 };
  enum { SET_PLAYHEAD = 5 };
  enum { RELATIVE = 0 };
  enum { ABSOLUTE = 1 };

  typedef boost::shared_ptr< ::speakeasy::SpeakEasyMusic_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::speakeasy::SpeakEasyMusic_<ContainerAllocator>  const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;
}; // struct SpeakEasyMusic
typedef  ::speakeasy::SpeakEasyMusic_<std::allocator<void> > SpeakEasyMusic;

typedef boost::shared_ptr< ::speakeasy::SpeakEasyMusic> SpeakEasyMusicPtr;
typedef boost::shared_ptr< ::speakeasy::SpeakEasyMusic const> SpeakEasyMusicConstPtr;


template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const  ::speakeasy::SpeakEasyMusic_<ContainerAllocator> & v)
{
  ros::message_operations::Printer< ::speakeasy::SpeakEasyMusic_<ContainerAllocator> >::stream(s, "", v);
  return s;}

} // namespace speakeasy

namespace ros
{
namespace message_traits
{
template<class ContainerAllocator> struct IsMessage< ::speakeasy::SpeakEasyMusic_<ContainerAllocator> > : public TrueType {};
template<class ContainerAllocator> struct IsMessage< ::speakeasy::SpeakEasyMusic_<ContainerAllocator>  const> : public TrueType {};
template<class ContainerAllocator>
struct MD5Sum< ::speakeasy::SpeakEasyMusic_<ContainerAllocator> > {
  static const char* value() 
  {
    return "27f69ade9b4ae81e70327b165235700a";
  }

  static const char* value(const  ::speakeasy::SpeakEasyMusic_<ContainerAllocator> &) { return value(); } 
  static const uint64_t static_value1 = 0x27f69ade9b4ae81eULL;
  static const uint64_t static_value2 = 0x70327b165235700aULL;
};

template<class ContainerAllocator>
struct DataType< ::speakeasy::SpeakEasyMusic_<ContainerAllocator> > {
  static const char* value() 
  {
    return "speakeasy/SpeakEasyMusic";
  }

  static const char* value(const  ::speakeasy::SpeakEasyMusic_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator>
struct Definition< ::speakeasy::SpeakEasyMusic_<ContainerAllocator> > {
  static const char* value() 
  {
    return "# Request that SpeakEasy node play a named sound file, which\n\
# is stored as a .wav or .ogg file on the node's machine. \n\
# The sound will play on the speakers that are connected\n\
# to the node's machine. Use this message for sounds that \n\
# are longer than very brief sound effects, like songs.\n\
# Use SoundPlay.msg for short sounds. Only one song \n\
# will play, but many sounds can play at the same time.\n\
#\n\
# Command API:\n\
#\n\
#  play(songName, repeats=, startTime=, volume=)\n\
#  stop()\n\
#  pause()\n\
#  unpause()\n\
#  setVol(volume)\n\
#  setPlayhead(time, timeReference=)\n\
\n\
# Command Codes:\n\
int8 PLAY = 0\n\
int8 STOP = 1\n\
int8 PAUSE = 2\n\
int8 UNPAUSE = 3\n\
int8 SET_VOL = 4\n\
int8 SET_PLAYHEAD = 5\n\
\n\
# For setPlayhead(): whether time spec is intended relative to\n\
# the current playhead position, or absolute from the start:\n\
int8 RELATIVE = 0\n\
int8 ABSOLUTE = 1\n\
\n\
# Parameters:\n\
int8 command  		  # One of the above Command codes\n\
\n\
string song_name          # Music/Song file name with or without file extension.\n\
int8   repeats            # Optional, and only relevant for play(). Default is to play once (zero repeats)\n\
			  # Required for play(). Optional for others\n\
float32 volume            # Values that cause change: 0.0 to 1.0. Set - -1.0 to use currently set vol.\n\
float32 time              # Optional for play(): How far into a song to start playing \n\
			  # Mandatory for setPlayhead().\n\
int8   timeReference	  # One of RELATIVE or ABSOLUTE					 \n\
\n\
";
  }

  static const char* value(const  ::speakeasy::SpeakEasyMusic_<ContainerAllocator> &) { return value(); } 
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

template<class ContainerAllocator> struct Serializer< ::speakeasy::SpeakEasyMusic_<ContainerAllocator> >
{
  template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
  {
    stream.next(m.command);
    stream.next(m.song_name);
    stream.next(m.repeats);
    stream.next(m.volume);
    stream.next(m.time);
    stream.next(m.timeReference);
  }

  ROS_DECLARE_ALLINONE_SERIALIZER;
}; // struct SpeakEasyMusic_
} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::speakeasy::SpeakEasyMusic_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const  ::speakeasy::SpeakEasyMusic_<ContainerAllocator> & v) 
  {
    s << indent << "command: ";
    Printer<int8_t>::stream(s, indent + "  ", v.command);
    s << indent << "song_name: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.song_name);
    s << indent << "repeats: ";
    Printer<int8_t>::stream(s, indent + "  ", v.repeats);
    s << indent << "volume: ";
    Printer<float>::stream(s, indent + "  ", v.volume);
    s << indent << "time: ";
    Printer<float>::stream(s, indent + "  ", v.time);
    s << indent << "timeReference: ";
    Printer<int8_t>::stream(s, indent + "  ", v.timeReference);
  }
};


} // namespace message_operations
} // namespace ros

#endif // SPEAKEASY_MESSAGE_SPEAKEASYMUSIC_H

