/* Auto-generated by genmsg_cpp for file /tmp/buildd/ros-fuerte-speakeasy-0.1.3/debian/ros-fuerte-speakeasy/opt/ros/fuerte/stacks/speakeasy/msg/SpeakEasySound.msg */
#ifndef SPEAKEASY_MESSAGE_SPEAKEASYSOUND_H
#define SPEAKEASY_MESSAGE_SPEAKEASYSOUND_H
#include <string>
#include <vector>
#include <map>
#include <ostream>
#include "ros/serialization.h"
#include "ros/builtin_message_traits.h"
#include "ros/message_operations.h"
#include "ros/time.h"

#include "ros/macros.h"

#include "ros/assert.h"


namespace speakeasy
{
template <class ContainerAllocator>
struct SpeakEasySound_ {
  typedef SpeakEasySound_<ContainerAllocator> Type;

  SpeakEasySound_()
  : command(0)
  , sound_name()
  , volume(0.0)
  {
  }

  SpeakEasySound_(const ContainerAllocator& _alloc)
  : command(0)
  , sound_name(_alloc)
  , volume(0.0)
  {
  }

  typedef int8_t _command_type;
  int8_t command;

  typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _sound_name_type;
  std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  sound_name;

  typedef float _volume_type;
  float volume;

  enum { PLAY = 0 };
  enum { STOP = 1 };
  enum { PAUSE = 2 };
  enum { UNPAUSE = 3 };
  enum { SET_VOL = 4 };

  typedef boost::shared_ptr< ::speakeasy::SpeakEasySound_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::speakeasy::SpeakEasySound_<ContainerAllocator>  const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;
}; // struct SpeakEasySound
typedef  ::speakeasy::SpeakEasySound_<std::allocator<void> > SpeakEasySound;

typedef boost::shared_ptr< ::speakeasy::SpeakEasySound> SpeakEasySoundPtr;
typedef boost::shared_ptr< ::speakeasy::SpeakEasySound const> SpeakEasySoundConstPtr;


template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const  ::speakeasy::SpeakEasySound_<ContainerAllocator> & v)
{
  ros::message_operations::Printer< ::speakeasy::SpeakEasySound_<ContainerAllocator> >::stream(s, "", v);
  return s;}

} // namespace speakeasy

namespace ros
{
namespace message_traits
{
template<class ContainerAllocator> struct IsMessage< ::speakeasy::SpeakEasySound_<ContainerAllocator> > : public TrueType {};
template<class ContainerAllocator> struct IsMessage< ::speakeasy::SpeakEasySound_<ContainerAllocator>  const> : public TrueType {};
template<class ContainerAllocator>
struct MD5Sum< ::speakeasy::SpeakEasySound_<ContainerAllocator> > {
  static const char* value() 
  {
    return "fbd2bf7b71afc58acf6706ab513017ac";
  }

  static const char* value(const  ::speakeasy::SpeakEasySound_<ContainerAllocator> &) { return value(); } 
  static const uint64_t static_value1 = 0xfbd2bf7b71afc58aULL;
  static const uint64_t static_value2 = 0xcf6706ab513017acULL;
};

template<class ContainerAllocator>
struct DataType< ::speakeasy::SpeakEasySound_<ContainerAllocator> > {
  static const char* value() 
  {
    return "speakeasy/SpeakEasySound";
  }

  static const char* value(const  ::speakeasy::SpeakEasySound_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator>
struct Definition< ::speakeasy::SpeakEasySound_<ContainerAllocator> > {
  static const char* value() 
  {
    return "# Request that SpeakEasy node play a named sound, which\n\
# is stored as a .wav file on the node's machine. \n\
# The sound will play on the speakers that are connected\n\
# to the node's machine. Use this message for short\n\
# sounds. For music, use MusicPlay.msg. Many sounds can\n\
# play at the same time; only one piece of music can play\n\
# at once.\n\
#\n\
# Command API:\n\
#  play(soundName, volume=)\n\
#  stop(soundName=)\n\
#  pause(soundName=)\n\
#  unpause(soundName=)\n\
#  setVol(newVol, soundName)\n\
\n\
# Commands\n\
int8 PLAY=0\n\
int8 STOP=1\n\
int8 PAUSE=2\n\
int8 UNPAUSE=3\n\
int8 SET_VOL=4\n\
\n\
int8 command              # One of the above Command codes\n\
string sound_name         # Sound file name with or without file extension.\n\
						  # Required for play(). Optional for others\n\
float32 volume            # Values that cause change: 0.0 to 1.0. Set - -1.0 to use currently set vol.\n\
\n\
\n\
";
  }

  static const char* value(const  ::speakeasy::SpeakEasySound_<ContainerAllocator> &) { return value(); } 
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

template<class ContainerAllocator> struct Serializer< ::speakeasy::SpeakEasySound_<ContainerAllocator> >
{
  template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
  {
    stream.next(m.command);
    stream.next(m.sound_name);
    stream.next(m.volume);
  }

  ROS_DECLARE_ALLINONE_SERIALIZER;
}; // struct SpeakEasySound_
} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::speakeasy::SpeakEasySound_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const  ::speakeasy::SpeakEasySound_<ContainerAllocator> & v) 
  {
    s << indent << "command: ";
    Printer<int8_t>::stream(s, indent + "  ", v.command);
    s << indent << "sound_name: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.sound_name);
    s << indent << "volume: ";
    Printer<float>::stream(s, indent + "  ", v.volume);
  }
};


} // namespace message_operations
} // namespace ros

#endif // SPEAKEASY_MESSAGE_SPEAKEASYSOUND_H

