"""autogenerated by genpy from speakeasy/SpeakEasyMusic.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class SpeakEasyMusic(genpy.Message):
  _md5sum = "27f69ade9b4ae81e70327b165235700a"
  _type = "speakeasy/SpeakEasyMusic"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# Request that SpeakEasy node play a named sound file, which
# is stored as a .wav or .ogg file on the node's machine. 
# The sound will play on the speakers that are connected
# to the node's machine. Use this message for sounds that 
# are longer than very brief sound effects, like songs.
# Use SoundPlay.msg for short sounds. Only one song 
# will play, but many sounds can play at the same time.
#
# Command API:
#
#  play(songName, repeats=, startTime=, volume=)
#  stop()
#  pause()
#  unpause()
#  setVol(volume)
#  setPlayhead(time, timeReference=)

# Command Codes:
int8 PLAY = 0
int8 STOP = 1
int8 PAUSE = 2
int8 UNPAUSE = 3
int8 SET_VOL = 4
int8 SET_PLAYHEAD = 5

# For setPlayhead(): whether time spec is intended relative to
# the current playhead position, or absolute from the start:
int8 RELATIVE = 0
int8 ABSOLUTE = 1

# Parameters:
int8 command  		  # One of the above Command codes

string song_name          # Music/Song file name with or without file extension.
int8   repeats            # Optional, and only relevant for play(). Default is to play once (zero repeats)
			  # Required for play(). Optional for others
float32 volume            # Values that cause change: 0.0 to 1.0. Set - -1.0 to use currently set vol.
float32 time              # Optional for play(): How far into a song to start playing 
			  # Mandatory for setPlayhead().
int8   timeReference	  # One of RELATIVE or ABSOLUTE					 

"""
  # Pseudo-constants
  PLAY = 0
  STOP = 1
  PAUSE = 2
  UNPAUSE = 3
  SET_VOL = 4
  SET_PLAYHEAD = 5
  RELATIVE = 0
  ABSOLUTE = 1

  __slots__ = ['command','song_name','repeats','volume','time','timeReference']
  _slot_types = ['int8','string','int8','float32','float32','int8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       command,song_name,repeats,volume,time,timeReference

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SpeakEasyMusic, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.command is None:
        self.command = 0
      if self.song_name is None:
        self.song_name = ''
      if self.repeats is None:
        self.repeats = 0
      if self.volume is None:
        self.volume = 0.
      if self.time is None:
        self.time = 0.
      if self.timeReference is None:
        self.timeReference = 0
    else:
      self.command = 0
      self.song_name = ''
      self.repeats = 0
      self.volume = 0.
      self.time = 0.
      self.timeReference = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      buff.write(_struct_b.pack(self.command))
      _x = self.song_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_b2fb.pack(_x.repeats, _x.volume, _x.time, _x.timeReference))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      end = 0
      start = end
      end += 1
      (self.command,) = _struct_b.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.song_name = str[start:end].decode('utf-8')
      else:
        self.song_name = str[start:end]
      _x = self
      start = end
      end += 10
      (_x.repeats, _x.volume, _x.time, _x.timeReference,) = _struct_b2fb.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      buff.write(_struct_b.pack(self.command))
      _x = self.song_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_b2fb.pack(_x.repeats, _x.volume, _x.time, _x.timeReference))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      end = 0
      start = end
      end += 1
      (self.command,) = _struct_b.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.song_name = str[start:end].decode('utf-8')
      else:
        self.song_name = str[start:end]
      _x = self
      start = end
      end += 10
      (_x.repeats, _x.volume, _x.time, _x.timeReference,) = _struct_b2fb.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_b2fb = struct.Struct("<b2fb")
_struct_b = struct.Struct("<b")
