"""autogenerated by genpy from speakeasy/SpeakEasySound.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class SpeakEasySound(genpy.Message):
  _md5sum = "fbd2bf7b71afc58acf6706ab513017ac"
  _type = "speakeasy/SpeakEasySound"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# Request that SpeakEasy node play a named sound, which
# is stored as a .wav file on the node's machine. 
# The sound will play on the speakers that are connected
# to the node's machine. Use this message for short
# sounds. For music, use MusicPlay.msg. Many sounds can
# play at the same time; only one piece of music can play
# at once.
#
# Command API:
#  play(soundName, volume=)
#  stop(soundName=)
#  pause(soundName=)
#  unpause(soundName=)
#  setVol(newVol, soundName)

# Commands
int8 PLAY=0
int8 STOP=1
int8 PAUSE=2
int8 UNPAUSE=3
int8 SET_VOL=4

int8 command              # One of the above Command codes
string sound_name         # Sound file name with or without file extension.
						  # Required for play(). Optional for others
float32 volume            # Values that cause change: 0.0 to 1.0. Set - -1.0 to use currently set vol.


"""
  # Pseudo-constants
  PLAY = 0
  STOP = 1
  PAUSE = 2
  UNPAUSE = 3
  SET_VOL = 4

  __slots__ = ['command','sound_name','volume']
  _slot_types = ['int8','string','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       command,sound_name,volume

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SpeakEasySound, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.command is None:
        self.command = 0
      if self.sound_name is None:
        self.sound_name = ''
      if self.volume is None:
        self.volume = 0.
    else:
      self.command = 0
      self.sound_name = ''
      self.volume = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      buff.write(_struct_b.pack(self.command))
      _x = self.sound_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_f.pack(self.volume))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      end = 0
      start = end
      end += 1
      (self.command,) = _struct_b.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.sound_name = str[start:end].decode('utf-8')
      else:
        self.sound_name = str[start:end]
      start = end
      end += 4
      (self.volume,) = _struct_f.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      buff.write(_struct_b.pack(self.command))
      _x = self.sound_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_f.pack(self.volume))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      end = 0
      start = end
      end += 1
      (self.command,) = _struct_b.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.sound_name = str[start:end].decode('utf-8')
      else:
        self.sound_name = str[start:end]
      start = end
      end += 4
      (self.volume,) = _struct_f.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_b = struct.Struct("<b")
_struct_f = struct.Struct("<f")
