"""autogenerated by genpy from speakeasy/SpeakEasyStatus.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import speakeasy.msg

class SpeakEasyStatus(genpy.Message):
  _md5sum = "1ba9da1769696107aa3767cd3c7fafdd"
  _type = "speakeasy/SpeakEasyStatus"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# Latched message from SpeakEasy service to communicate
# its available:
#    - Text-to-speech engine names (e.g. ['festival', 'cepstral'])
#    - Voices for each text-to-speech engine (e.g. ['David'])
#    - Sound files (e.g. ['drill.wav', 'bomb.ogg'])
#    - Song files
#    - Number of sounds that may play simultaneously
#    - Music play status: Stopped, paused, or playing.
#    - Current sound effects volume
#    - Current music volume

# Play Status codes:
int8   STOPPED = 0
int8   PAUSED  = 1
int8   PLAYING = 2
 

string[]    ttsEngines
TtsVoices[] voices
string[]    sounds
string[]    music
int8	    numSoundChannels
int8        musicStatus
bool	    textToSpeechBusy
float32     soundVolume
float32     musicVolume


================================================================================
MSG: speakeasy/TtsVoices
# Helper ROS message type to list available voices
# for a given text-to-speech engine.

string ttsEngine
string[] voices

"""
  # Pseudo-constants
  STOPPED = 0
  PAUSED = 1
  PLAYING = 2

  __slots__ = ['ttsEngines','voices','sounds','music','numSoundChannels','musicStatus','textToSpeechBusy','soundVolume','musicVolume']
  _slot_types = ['string[]','speakeasy/TtsVoices[]','string[]','string[]','int8','int8','bool','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       ttsEngines,voices,sounds,music,numSoundChannels,musicStatus,textToSpeechBusy,soundVolume,musicVolume

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SpeakEasyStatus, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.ttsEngines is None:
        self.ttsEngines = []
      if self.voices is None:
        self.voices = []
      if self.sounds is None:
        self.sounds = []
      if self.music is None:
        self.music = []
      if self.numSoundChannels is None:
        self.numSoundChannels = 0
      if self.musicStatus is None:
        self.musicStatus = 0
      if self.textToSpeechBusy is None:
        self.textToSpeechBusy = False
      if self.soundVolume is None:
        self.soundVolume = 0.
      if self.musicVolume is None:
        self.musicVolume = 0.
    else:
      self.ttsEngines = []
      self.voices = []
      self.sounds = []
      self.music = []
      self.numSoundChannels = 0
      self.musicStatus = 0
      self.textToSpeechBusy = False
      self.soundVolume = 0.
      self.musicVolume = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.ttsEngines)
      buff.write(_struct_I.pack(length))
      for val1 in self.ttsEngines:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.voices)
      buff.write(_struct_I.pack(length))
      for val1 in self.voices:
        _x = val1.ttsEngine
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.voices)
        buff.write(_struct_I.pack(length))
        for val2 in val1.voices:
          length = len(val2)
          if python3 or type(val2) == unicode:
            val2 = val2.encode('utf-8')
            length = len(val2)
          buff.write(struct.pack('<I%ss'%length, length, val2))
      length = len(self.sounds)
      buff.write(_struct_I.pack(length))
      for val1 in self.sounds:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.music)
      buff.write(_struct_I.pack(length))
      for val1 in self.music:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
      _x = self
      buff.write(_struct_2bB2f.pack(_x.numSoundChannels, _x.musicStatus, _x.textToSpeechBusy, _x.soundVolume, _x.musicVolume))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.voices is None:
        self.voices = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.ttsEngines = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8')
        else:
          val1 = str[start:end]
        self.ttsEngines.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.voices = []
      for i in range(0, length):
        val1 = speakeasy.msg.TtsVoices()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.ttsEngine = str[start:end].decode('utf-8')
        else:
          val1.ttsEngine = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.voices = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2 = str[start:end].decode('utf-8')
          else:
            val2 = str[start:end]
          val1.voices.append(val2)
        self.voices.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.sounds = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8')
        else:
          val1 = str[start:end]
        self.sounds.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.music = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8')
        else:
          val1 = str[start:end]
        self.music.append(val1)
      _x = self
      start = end
      end += 11
      (_x.numSoundChannels, _x.musicStatus, _x.textToSpeechBusy, _x.soundVolume, _x.musicVolume,) = _struct_2bB2f.unpack(str[start:end])
      self.textToSpeechBusy = bool(self.textToSpeechBusy)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.ttsEngines)
      buff.write(_struct_I.pack(length))
      for val1 in self.ttsEngines:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.voices)
      buff.write(_struct_I.pack(length))
      for val1 in self.voices:
        _x = val1.ttsEngine
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.voices)
        buff.write(_struct_I.pack(length))
        for val2 in val1.voices:
          length = len(val2)
          if python3 or type(val2) == unicode:
            val2 = val2.encode('utf-8')
            length = len(val2)
          buff.write(struct.pack('<I%ss'%length, length, val2))
      length = len(self.sounds)
      buff.write(_struct_I.pack(length))
      for val1 in self.sounds:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.music)
      buff.write(_struct_I.pack(length))
      for val1 in self.music:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
      _x = self
      buff.write(_struct_2bB2f.pack(_x.numSoundChannels, _x.musicStatus, _x.textToSpeechBusy, _x.soundVolume, _x.musicVolume))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.voices is None:
        self.voices = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.ttsEngines = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8')
        else:
          val1 = str[start:end]
        self.ttsEngines.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.voices = []
      for i in range(0, length):
        val1 = speakeasy.msg.TtsVoices()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.ttsEngine = str[start:end].decode('utf-8')
        else:
          val1.ttsEngine = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.voices = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2 = str[start:end].decode('utf-8')
          else:
            val2 = str[start:end]
          val1.voices.append(val2)
        self.voices.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.sounds = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8')
        else:
          val1 = str[start:end]
        self.sounds.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.music = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8')
        else:
          val1 = str[start:end]
        self.music.append(val1)
      _x = self
      start = end
      end += 11
      (_x.numSoundChannels, _x.musicStatus, _x.textToSpeechBusy, _x.soundVolume, _x.musicVolume,) = _struct_2bB2f.unpack(str[start:end])
      self.textToSpeechBusy = bool(self.textToSpeechBusy)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_2bB2f = struct.Struct("<2bB2f")
